package de.uni_passau.fim.PADAS.group3.DataDash.model;

import java.util.List;
import java.util.Optional;
import java.util.UUID;
import java.sql.Date;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;


public interface dataRepository extends JpaRepository<Dataset, UUID> {

        Dataset getDatasetById(UUID id);

        List<Dataset> findByTitle(String title);

        List<Dataset> findByTitleLike(String title);

        List<Dataset> findByAuthorLike(String author);

        List<Dataset> findByType(Type type);

        List<Dataset> findByAuthor(String author);

        List<Dataset> findByAbstLike(String abst);

        List<Dataset> findByDescriptionLike(String description);

        List<Dataset> findByRaitingGreaterThan(float raiting);

        List<Dataset> findByVotesGreaterThan(int votes);

        List<Dataset> findByDateAfter(Date date);

        List<Dataset> findByDateBefore(Date date);

        List<Dataset> findByCategorie(Category categorie);

        List<Dataset> findByDateBetween(Date date1, Date date2);

        @SuppressWarnings("null")
        Page<Dataset> findAll(Pageable pageable);

        @Query("SELECT d FROM Dataset d WHERE " +
                        "(COALESCE(:title, '') = '' OR d.title LIKE :title) AND " +
                        "(COALESCE(:description, '') = '' OR d.description LIKE :description) AND" +
                        "(COALESCE(:author, '') = '' OR d.author LIKE :author) AND" +
                        "(COALESCE(:abst, '') = '' OR d.abst LIKE :abst) AND" +
                        "(:type IS NULL OR d.type = :type) AND" +
                        "(:categorie IS NULL OR d.categorie = :categorie) AND" +
                        "(:raiting IS NULL OR d.raiting > :raiting)")
        Page<Dataset> findByOptionalCriteria(@Param("title") Optional<String> title,
                        @Param("description") Optional<String> description,
                        @Param("author") Optional<String> author,
                        @Param("abst") Optional<String> abst,
                        @Param("type") Optional<Type> type,
                        @Param("categorie") Optional<Category> categories,
                        @Param("raiting") Optional<Float> raiting,
                        Pageable pageable);

        @Query("SELECT d FROM Dataset d WHERE " +
                        "(LOWER(d.title) LIKE LOWER(:search)) OR " +
                        "(LOWER(d.description) LIKE LOWER(:search)) OR " +
                        "(LOWER(d.author) LIKE LOWER(:search))")
        Page<Dataset> searchByOptionalCriteria(@Param("search") Optional<String> search,
                        Pageable pageable);
}